/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

function registerPushwooshIOS() {
    var pushNotification = window.plugins.pushNotification;

    //set push notification callback before we initialize the plugin
    document.addEventListener('push-notification',
        function(event) {
            //get the notification payload
            var notification = event.notification;
            //display alert to the user for example
            // alert(notification.aps.alert);
            window.location.href = "inbox.html";
            //to view full push payload
            if (typeof localStorage.accessToken == "undefined") {
                pushNotification.setApplicationIconBadgeNumber(0);
            }
            if (localStorage.inCount >= 0 && typeof localStorage.accessToken != "undefined") {
                pushNotification.setApplicationIconBadgeNumber(localStorage.inCount);
            }
        }
    );

    //trigger pending push notifications
    pushNotification.onDeviceReady();

    //register for pushes.
    //!!! Please note this is an API for PGB plugin. This code is different in CLI plugin!!!
    //At the moment I cannot update the plugin to the latest version. TY PGB Team!
    //see http://community.phonegap.com/nitobi/topics/malformed_xml_in_plugin_xml_file?utm_source=notification&utm_medium=email&utm_campaign=new_reply&utm_content=reply_button&reply%5Bid%5D=14224918#reply_14224918
    pushNotification.registerDevice({
            alert: true,
            badge: true,
            sound: true,
            pw_appid: "B18F2-BC5F3",
            appname: "Rappit"
        },
        function(status) {
            var deviceToken = status.deviceToken;
            console.warn('registerDevice: ' + deviceToken);
            var link;
            var usertoken = localStorage.token;
            var FBtoken = localStorage.accessToken;
            if (typeof usertoken != "undefined") {
                link = 'http://rappit.dk/api/pushwoosh.json?token=' + usertoken;
            }
            if (typeof FBtoken != "undefined") {
                link = 'http://rappit.dk/api/pushwoosh.json?ftoken=' + FBtoken;
            }
            $.ajax({
                type: "POST",
                url: link,
                data: "pwtoken=" + deviceToken,
                success: function(result) {
					onPushwooshiOSInitialized(deviceToken);
                    // alert(JSON.stringify(result));
                },
                error: function(result) {
                    // alert(JSON.stringify(result));
                }
            });
        },
        function(status) {
            console.warn('failed to register : ' + JSON.stringify(status));
            //alert(JSON.stringify(['failed to register ', status]));
        }
    );

    if (typeof localStorage.accessToken == "undefined") {
        pushNotification.setApplicationIconBadgeNumber(0);
    }
    if (localStorage.inCount >= 0 && typeof localStorage.accessToken != "undefined") {
        pushNotification.setApplicationIconBadgeNumber(localStorage.inCount);
    }
}

function onPushwooshiOSInitialized(pushToken) {
    var pushNotification = window.plugins.pushNotification;
    //retrieve the tags for the device
    pushNotification.getTags(
        function(tags) {
            console.warn('tags for the device: ' + JSON.stringify(tags));
        },
        function(error) {
            console.warn('get tags error: ' + JSON.stringify(error));
        }
    );
}
