$(function() {
	var lt, lng, latlng, res, currpos;
	var v = localStorage.getItem('navcat');
	var directionsDisplay;
	var directionsService = new google.maps.DirectionsService();
	var cd = localStorage.getItem('cid');
	var link;
	var infowindow;
	var usertoken = localStorage.token;
	var FBtoken = localStorage.accessToken;

	function initialize() {
		directionsDisplay = new google.maps.DirectionsRenderer();

		var mapOptions = {
			zoom: 11,
			center: getCenter(),
			bounds: false
		}
		var map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
		directionsDisplay.setMap(map);

		function getImage() {
			var cats = localStorage.getItem('navcat');
			if (cats == 'other')
				return 'marker-other';
			else if (cats == 'helthcare_beauty')
				return 'marker-helthcare-beauty';
			else if (cats == 'events_culture')
				return 'marker-events-culture';
			else if (cats == 'cafes_restaurants')
				return 'marker-cafes-restaurants';
			else if (cats == 'bar_nightlife')
				return 'marker-bar-nightlife';
			else
				return 'marker-default';
		}

		var markers = "";
		var image = {
			url: 'images/' + getImage() + '.png'
		}
		var pos = new google.maps.LatLng(lt, lng);
		markers = new google.maps.Marker({
			position: pos,
			map: map,
			icon: image,
			draggable: false,
		});

		if (typeof usertoken != "undefined") {
			link = 'http://rappit.dk/api/map.json?token=' + usertoken + '&id=' + cd;
		}
		if (typeof FBtoken != "undefined") {
			link = 'http://rappit.dk/api/map.json?ftoken=' + FBtoken + '&id=' + cd;
		}

		$.ajax({
			type: 'GET',
			datatype: "JSON",
			url: link,
			success: function(data) {
				var contentStringCompany = "<div style='width:180px;display: block;overflow: show;text-transform: capitalize;font-size: 14px;><a class='company-info' data-icid='" + data.id + "'" + " onclick=redirect(this)><span class='company-info-right'><span class='company-name'>" + data.name + "</span><span class='company-desc'>" + data.description + "</span><span class='total-deals-count'>Tilbud, nyhed eller event: " + data.todalDeals + "</span></span><br/><span style='float:left; font-size:11px; width:100%; text-align:left'>Klik Her<img src='images/detailsimg.png' alt='' width='12'></span></a></div>";

				var infowindow = new google.maps.InfoWindow({
					content: contentStringCompany
				});
				infowindow = new google.maps.InfoWindow({
					position: pos,
					content: contentStringCompany,
					disableAutoPan: false,
				});

				infowindow.open(map, markers);
				google.maps.event.addListener(markers, 'click', function() {
					infowindow.open(map, markers);
				});

				google.maps.event.addListener(map, 'click', function() {
					infowindow.close();
				});
			},
			error: function() {}
		});

		// Try HTML5 geolocation

		$(function() {
			document.addEventListener("deviceready", onDeviceReadyGeo, false);
		});

		function onDeviceReadyGeo() {
			if (navigator.geolocation) {
				navigator.geolocation.getCurrentPosition(function(position) {
					currpos = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
					var homemarker = new google.maps.Marker({
						position: currpos,
						map: map,
						icon: 'images/home-marker.png',
						draggable: false,
						// center: currpos
					});
					map.setCenter(currpos);
				}, function() {
					handleNoGeolocation(true);
				});
			} else {
				// Browser doesn't support Geolocation
				handleNoGeolocation(false);
			}
		}

		function handleNoGeolocation(errorFlag) {
			if (errorFlag) {
				var content = 'Error: The Geolocation service failed.';
			} else {
				var content = 'Error: Your browser doesn\'t support geolocation,please update to the latest version of your browser.';
			}
			var options = {
				map: map,
				position: new google.maps.LatLng(60, 105),
				content: content
			};
			var infowindow = new google.maps.InfoWindow(options);
			map.setCenter(options.position);
		}
	}

	function getCenter() {
		lt = localStorage.getItem('navlat');
		lng = localStorage.getItem('navlang');
		latlng = new google.maps.LatLng(lt, lng);
		return latlng;
	}

	initialize();
	google.maps.event.addDomListener(window, 'load', initialize);
});